
-- heavy turret
-- created for SOLA
-- ask before stealing this
-- -Pacola

freeslot("SPR_HETU", "S_SOLA_TURRET", "MT_SOLA_HTURRET", "MT_HEAVY_BUELET")

states[S_SOLA_TURRET] = {
    sprite = SPR_HETU,
    frame = A,
    tics = -1,
    nextstate = S_SOLA_TURRET
}

mobjinfo[MT_SOLA_HTURRET] = {
	--$Title heavy turret
	--$Sprite HETUA1
	--$Category SOLA
	--$Angled
	doomednum = 17355,
	spawnhealth = 1,
	spawnstate = S_SOLA_TURRET,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	height = 93*FRACUNIT, -- FU isn't supported in the map thing right???
	radius = 46*FRACUNIT,
	flags = MF_SOLID
}

mobjinfo[MT_HEAVY_BUELET] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	height = 8*FU,
	radius = 8*FU,
	speed = 16*FU,
	flags = MF_MISSILE
}

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	
	for i = 0, 256 do
		if not (mo and mo.valid) then return end -- IS THIS GOOD ENOUGH SRB2
		
		local x, y = cos(mo.angle), sin(mo.angle)
		local spd = mo.info.speed
		P_SetOrigin(mo, mo.x+FixedMul(spd, x), mo.y+FixedMul(spd, y), mo.z+mo.momz)
		
		if not P_TryMove(mo, mo.x, mo.y, true)
			P_RemoveMobj(mo)
		end
	end
end, MT_HEAVY_BUELET)

sfxinfo[freeslot("sfx_hevsht")].caption = "heavy shooting turret yea"
for i = 1, 4 do
	sfxinfo[freeslot("sfx_hevid"+i)].caption = "heavy idling "+i
end

addHook("MobjSpawn", function(mo)
	mo.angadd = {
		val = 0,
		add = 1
	}
end, MT_SOLA_HTURRET)

addHook("MobjThinker", function(mo)
	if mo.turretang == nil then
		mo.turretang = mo.angle
		mo.spritexscale = $/3
		mo.spriteyscale = $/3
	end
	
	local aa = mo.angadd
	if aa.val > -45*FU and aa.add == -1
	or aa.val < 45*FU and aa.add == 1
		aa.val = $+FU*aa.add
	else
		aa.add = -$
	end
	
	P_LookForPlayers(mo, 0)
	
	if mo.target and mo.target.valid
		/*if R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y) >= 1024*FU
			mo.target = nil
			return
		end*/
		
		if leveltime%5 == 0
			P_SpawnMissile(mo, mo.target, MT_HEAVY_BUELET)
		end
		
		if not S_SoundPlaying(mo, sfx_hevsht)
			S_StartSound(mo, sfx_hevsht)
		end
		
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
	elseif leveltime%(5*TICRATE) == 0
		S_StartSound(mo, _G["sfx_hevid"+P_RandomRange(1, 4)])
	else
		mo.angle = mo.turretang+FixedAngle(aa.val)
	end
end, MT_SOLA_HTURRET)